# ANSIColoredPrinters

[![Docs Stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliadocs.github.io/ANSIColoredPrinters.jl/stable)
[![Docs Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliadocs.github.io/ANSIColoredPrinters.jl/dev)
[![CI](https://github.com/JuliaDocs/ANSIColoredPrinters.jl/workflows/CI/badge.svg)](https://github.com/JuliaDocs/ANSIColoredPrinters.jl/actions?query=workflow%3ACI)
[![Codecov](https://codecov.io/gh/JuliaDocs/ANSIColoredPrinters.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/JuliaDocs/ANSIColoredPrinters.jl)

`ANSIColoredPrinters` convert a text qualified by
[ANSI escape codes](https://en.wikipedia.org/wiki/ANSI_escape_code) to another
format.

struct PlainTextPrinter <: FlatModelPrinter
    buf::IO
    prevctx::SGRContext
    ctx::SGRContext
    function PlainTextPrinter(buf::IO)
        new(buf, SGRContext(), SGRContext())
    end
end

"""
    PlainTextPrinter(buf::IO)

Creates a printer for `MIME"text/plain"` output.

# Arguments
- `buf`: A source `IO` object containing a text with ANSI escape codes.
"""
function PlainTextPrinter end

Base.showable(::MIME"text/plain", printer::PlainTextPrinter) = isreadable(printer.buf)

function Base.show(io::IO, ::MIME"text/plain", printer::PlainTextPrinter)
    show_body(io, printer)
end

function change_state(io::IO, printer::PlainTextPrinter, ansicodes::Vector{Int})
    get(io, :color, false) || return
    if isempty(ansicodes)
        print(io, "\e[m")
    else
        print(io, "\e[", join(ansicodes, ';'), 'm')
    end
end

using Test, ANSIColoredPrinters

@testset "colors" begin
    include("colors.jl")
end
@testset "PlainTextPrinter" begin
    include("plain.jl")
end
@testset "HTMLPrinter" begin
    include("html.jl")
end

using Documenter, ANSIColoredPrinters

makedocs(
    clean = false,
    checkdocs = :exports,
    modules=[ANSIColoredPrinters],
    format=Documenter.HTML(prettyurls = get(ENV, "CI", nothing) == "true",
                           assets = ["assets/default.css"]),
    sitename="ANSIColoredPrinters",
    pages=[
        "Introduction" => "index.md",
        "Output Formats" => "output-formats.md",
        "Supported Codes" => "supported-codes.md",
        "Reference" => "reference.md",
    ]
)

deploydocs(
    repo="github.com/JuliaDocs/ANSIColoredPrinters.jl.git",
    devbranch = "main",
    push_preview = true
)

isnormal(c::SGRColor) = isempty(c.class)

is216color(c::SGRColor) = is216color(c.hex)

function is216color(hex::AbstractString)
    hex == "000" || hex == "fff" || occursin(r"(?:00|5f|87|af|d7|ff){3}$", hex)
end

function codes(c::SGRColor)
    m = match(r"^([345]8)_([25])$", c.class)
    m === nothing && return (parse(Int, c.class),)
    code, sub = m.captures
    codei = parse(Int, code)
    if sub == "5"
        if is216color(c)
            h = parse(UInt32, c.hex, base=16)
            h === 0x00000fff && return (codei, 5, 231)
            r = (h >> 0x10) % UInt8 ÷ 0x30
            g = (h >> 0x08) % UInt8 ÷ 0x30
            b = (h >> 0x00) % UInt8 ÷ 0x30
            return (codei, 5, (r * 0x24 + g * 0x6 + b) + 16)
        else
            h = parse(UInt8, c.hex[1:2], base=16)
            g = (h - 0x8) ÷ 0xa
            return (codei, 5, g + 232)
        end
    else
        if length(c.hex) == 3
            h = parse(UInt16, c.hex, base=16)
            r = (h >> 0x8)
            g = (h >> 0x4) & 0xf
            b = h & 0xf
            return (codei, 2, r * 17, g * 17, b * 17)
        else
            h = parse(UInt32, c.hex, base=16)
            r = (h >> 0x10)
            g = (h >> 0x8) & 0xff
            b = h & 0xff
            return (codei, 2, Int(r), Int(g), Int(b))
        end
    end
end

function short_hex(r::UInt8, g::UInt8, b::UInt8)
    rgb6 = UInt32(r) << 0x10 + UInt32(g) << 0x8 + b
    rgb6 === (rgb6 & 0x0f0f0f) * 0x11 || return string(rgb6, pad=6, base=16)
    string(UInt16(r >> 0x4) << 0x8 + UInt16(g >> 0x4) << 0x4 + b >> 0x4, pad=3, base=16)
end

function set_16colors!(ctx::SGRContext, d::AbstractString)
    if d[1] === '3' || d[1] === '9'
        ctx.fg = SGRColor(d)
    else
        ctx.bg = SGRColor(d)
    end
end

const SCALE_216 = UInt8[0x00, 0x5f, 0x87, 0xaf, 0xd7, 0xff]

function set_256colors!(ctx::SGRContext, d::AbstractString, color::AbstractString)
    fore = d[1] === '3'
    hex = ""
    colorid = isempty(color) ? 0x0 : parse(UInt8, color)
    if colorid < 0x8
        class = d[1] * string(colorid)
    elseif colorid < 0x10
        class = (fore ? "9" : "10") * string(colorid - 0x8)
    else
        if colorid < 0xe8
            c = colorid - 0x10
            r = SCALE_216[c ÷ 0x24 + 1]
            g = SCALE_216[c ÷ 0x6 % 0x6 + 1]
            b = SCALE_216[c % 0x6 + 1]
            hex = short_hex(r, g, b)
        else
            g = (colorid - 0xe8) * 0xa + 0x8
            hex = short_hex(g, g, g)
        end
        class = d * "_5"
    end

    if fore
        ctx.fg = SGRColor(class, hex)
    else
        ctx.bg = SGRColor(class, hex)
    end
end

function set_24bitcolors!(ctx::SGRContext, d::AbstractString,
                          r::AbstractString, g::AbstractString, b::AbstractString)
    r8 = isempty(r) ? 0x0 : parse(UInt8, r)
    g8 = isempty(g) ? 0x0 : parse(UInt8, g)
    b8 = isempty(b) ? 0x0 : parse(UInt8, b)
    hex = short_hex(r8, g8, b8)
    if is216color(hex) || (r8 === g8 === b8 && (r8 - 8) % 10 == 0)
        class = d * "_5"
    else
        class = d * "_2"
    end
    if d == "38"
        ctx.fg = SGRColor(class, hex)
    else
        ctx.bg = SGRColor(class, hex)
    end
end

struct HTMLPrinter <: StackModelPrinter
    buf::IO
    stack::Vector{String}
    prevctx::SGRContext
    ctx::SGRContext
    root_class::String
    root_tag::String
    callback::Any
    function HTMLPrinter(buf::IO;
                         root_class::AbstractString = "",
                         root_tag::AbstractString = "pre",
                         callback::Any = nothing)
        new(buf, String[], SGRContext(), SGRContext(),
            String(root_class), String(root_tag), callback)
    end
end

"""
    HTMLPrinter(buf::IO; root_class="", root_tag="pre", callback=nothing)

Creates a printer for `MIME"text/html"` output.

# Arguments
- `buf`: A source `IO` object containing a text with ANSI escape codes.
- `root_class`: The `class` attribute value for the root element.
- `root_tag`: The tag name for the root element.
- `callback`: A callback method (see below).

# Callback method

    callback(io::IO, printer::HTMLPrinter, tag::String, attrs::Dict{Symbol, String})

The `callback` method will be called just before writing HTML tags.

## Callback arguments
- `io`: The destination `IO` object.
- `printer`: The `HTMLPrinter` in use.
- `tag`: The HTML tag to be written. For closing tags, they have the prefix "/".
- `attrs`: A dictionary consisting of pairs of a `Symbol` for the attributes
  (e.g. `:class`, `:style`) and the `String` for its value.

## Callback return value
If the return value is `nothing`, the printer writes the HTML tag to the `io`
according to the `tag` and the `attrs` after the call. If the return value is
not `nothing`, this default writing will be prevented.
"""
function HTMLPrinter end

Base.showable(::MIME"text/html", printer::HTMLPrinter) = isreadable(printer.buf)

const HTML_ESC_CHARS = Dict{Char, String}(
    '\'' => "&#39;",
    '\"' => "&quot;",
    '<' => "&lt;",
    '>' => "&gt;",
    '&' => "&amp;",
)

escape_char(::HTMLPrinter, c::Char) = get(HTML_ESC_CHARS, c, nothing)

function Base.show(io::IO, ::MIME"text/html", printer::HTMLPrinter)
    tag = printer.root_tag
    attrs = Dict{Symbol, String}()
    isempty(printer.root_class) || push!(attrs, :class => printer.root_class)

    write_htmltag(io, printer, printer.root_tag, attrs)

    show_body(io, printer)

    write_htmltag(io, printer, "/" * printer.root_tag)
end

function start_new_state(io::IO, printer::HTMLPrinter)
    class = printer.stack[end]
    ctx = printer.ctx
    attrs = Dict{Symbol, String}(:class => "sgr" * class)

    if occursin(r"^38_[25]$", class)
        push!(attrs, :style => "color:#" * ctx.fg.hex)
    elseif occursin(r"^48_[25]$", class)
        push!(attrs, :style => "background:#" * ctx.bg.hex)
    end

    write_htmltag(io, printer, "span", attrs)
end

function end_current_state(io::IO, printer::HTMLPrinter)
    write_htmltag(io, printer, "/span", )
end

function write_htmltag(io::IO, printer::HTMLPrinter,
                       tag::String, attrs::Dict{Symbol, String} = Dict{Symbol, String}())
    if printer.callback !== nothing
        result = printer.callback(io, printer, tag, attrs)
        result === nothing || return
    end
    write(io, "<", tag)
    for k in sort!(collect(keys(attrs)))
        v = attrs[k]
        isempty(v) && continue
        write(io, " ", k, "=\"", v, "\"")
    end
    write(io, ">")
end

module ANSIColoredPrinters

import Base: ==, show, showable

export PlainTextPrinter, HTMLPrinter

abstract type AbstractPrinter end

"""
    StackModelPrinter

An abstract printer type for stack-based or tree model formats.
"""
abstract type StackModelPrinter <: AbstractPrinter end

"""
    FlatModelPrinter

An abstract printer type for non-stack-based formats.
"""
abstract type FlatModelPrinter <: AbstractPrinter end


struct SGRColor
    class::String
    hex::String
    SGRColor(class::AbstractString="", hex::AbstractString="") = new(class, hex)
end

mutable struct SGRContext
    fg::SGRColor
    bg::SGRColor
    flags::BitVector
    SGRContext() = new(SGRColor(), SGRColor(), falses(128))
end

include("colors.jl")
include("plain.jl")
include("html.jl")

==(a::SGRContext, b::SGRContext) = a.fg == b.fg && a.bg == b.bg && a.flags == b.flags

isnormal(ctx::SGRContext) = isnormal(ctx.fg) && isnormal(ctx.bg) && !any(ctx.flags)

function reset_color(ctx::SGRContext)
    ctx.fg = SGRColor()
    ctx.bg = SGRColor()
end

function reset(ctx::SGRContext)
    reset_color(ctx)
    ctx.flags .= false
end

function reset(printer::AbstractPrinter)
    seekstart(printer.buf)
    if printer isa StackModelPrinter
        while !isempty(printer.stack)
            pop!(printer.stack)
        end
    end
    reset(printer.ctx)
    reset(printer.prevctx)
end

function copy!(dest::SGRContext, src::SGRContext)
    dest.fg = src.fg
    dest.bg = src.bg
    dest.flags .= src.flags
end

escape_char(printer::AbstractPrinter, c::Char) = nothing

function show_body(io::IO, printer::AbstractPrinter)
    reset(printer)
    buf = printer.buf
    ctx_changed = false
    while !eof(buf)
        c = read(buf, Char)
        if c !== '\e'
            if ctx_changed
                apply_changes(io, printer)
                copy!(printer.prevctx, printer.ctx)
                ctx_changed = false
            end
            ec = escape_char(printer, c)
            write(io, ec === nothing ? c : ec)
            continue
        end
        ansiesc = IOBuffer()
        c = read(buf, Char)
        c === '[' || continue
        while !eof(buf)
            c = read(buf, Char)
            if '0' <= c <= '9' || c === ';' # strip spaces
                write(ansiesc, c)
            elseif c >= Char(0x40)
                break
            end
        end
        astr = String(take!(ansiesc))
        if c === 'm'
            while true
                astr = parse_sgrcodes(printer.ctx, astr)
                isempty(astr) && break
            end
        end
        ctx_changed = printer.prevctx != printer.ctx
    end

    finalize(io, printer)
end

function parse_sgrcodes(ctx::SGRContext, astr::AbstractString)
    if (m = match(r"^0?(?:;|$)", astr)) !== nothing
        reset(ctx)
    elseif (m = match(r"^22;?", astr)) !== nothing
        reset_color(ctx)
        ctx.flags[1:2] .= false
    elseif (m = match(r"^2([3-57-9]);?", astr)) !== nothing
        di = parse(Int, m.captures[1])
        ctx.flags[di] = false
        ctx.flags[di + (di === 5)] = false
    elseif (m = match(r"^39;?", astr)) !== nothing
        ctx.fg = SGRColor()
    elseif (m = match(r"^49;?", astr)) !== nothing
        ctx.bg = SGRColor()
    elseif (m = match(r"^([349][0-7]|10[0-7]);?", astr)) !== nothing
        set_16colors!(ctx, m.captures[1])
    elseif (m = match(r"^([345]8);5;(\d{0,3});?", astr)) !== nothing
        d, col = m.captures
        d != "58" && set_256colors!(ctx, d, col) # code 58 is not yet supported
    elseif (m = match(r"^([345]8);2;(\d{0,3});(\d{0,3});(\d{0,3});?", astr)) !== nothing
        d, rs, gs, bs = m.captures
        d != "58" && set_24bitcolors!(ctx, d, rs, gs, bs) # code 58 is not yet supported
    elseif (m = match(r"^(\d);?", astr)) !== nothing
        di = parse(Int, m.captures[1])
        if di === 1 || di === 2
            ctx.flags[1:2] .= (di === 1, di === 2)
        elseif di === 5 || di === 6
            ctx.flags[5:6] .= (di === 5, di === 6)
        else
            ctx.flags[di] = true
        end
    elseif (m = match(r"^(\d+);?", astr)) !== nothing
        # unsupported
    else # unknown
        return ""
    end
    return astr[m.offset + lastindex(m.match):end]
end

function apply_changes(io::IO, printer::StackModelPrinter)
    stack = printer.stack
    ctx = printer.ctx
    prevctx = printer.prevctx
    invert = prevctx.flags[7] != ctx.flags[7]

    marks = zeros(Bool, length(stack))
    nstack = String[]

    for di = 1:9
        if prevctx.flags[di] != ctx.flags[di]
            class = string(di)
            marks .|= map(c -> c == class, stack)
            ctx.flags[di] && push!(nstack, class)
        end
    end
    if prevctx.fg != ctx.fg || invert
        marks .|= map(c -> occursin(r"^(?:3[0-7]|9[0-7]|38_[25])$", c), stack)
        isnormal(ctx.fg) || push!(nstack, ctx.fg.class)
    end
    if prevctx.bg != ctx.bg || invert
        marks .|= map(c -> occursin(r"^(?:4[0-7]|10[0-7]|48_[25])$", c), stack)
        isnormal(ctx.bg) || push!(nstack, ctx.bg.class)
    end
    poplevel = findfirst(marks)
    if poplevel !== nothing
        while length(stack) >= poplevel
            end_current_state(io, printer)
            class = pop!(stack)
            pop!(marks) || push!(nstack, class)
        end
    end
    while !isempty(nstack)
        class = pop!(nstack)
        push!(stack, class)
        start_new_state(io, printer)
    end
end

function apply_changes(io::IO, printer::FlatModelPrinter)
    ansicodes = Int[]

    prevctx = printer.prevctx
    ctx = printer.ctx
    prevflags = prevctx.flags
    flags = ctx.flags

    prevctx == ctx && return

    if isnormal(ctx)
        change_state(io, printer, ansicodes)
        return
    end
    if prevflags[1] & !flags[1] || prevflags[2] & !flags[2]
        if !flags[1] && !flags[2]
            push!(ansicodes, 22)
            parse_sgrcodes(prevctx, "22")
        end
    end
    if prevflags[5] & !flags[5] || prevflags[6] & !flags[6]
        if !flags[5] && !flags[6]
            push!(ansicodes, 25)
            parse_sgrcodes(prevctx, "25")
        end
    end
    prevctx.fg != ctx.fg && append!(ansicodes, isnormal(ctx.fg) ? (39,) : codes(ctx.fg))
    prevctx.bg != ctx.bg && append!(ansicodes, isnormal(ctx.bg) ? (49,) : codes(ctx.bg))
    for i in 1:length(flags)
        prevflags[i] === flags[i] && continue
        if 1 <= i <= 2 || 5 <= i <= 6
            flags[i] && push!(ansicodes, i)
        elseif i <= 9
            push!(ansicodes, flags[i] ? i : i + 20)
        end
    end

    isempty(ansicodes) || change_state(io, printer, ansicodes)
end

function finalize(io::IO, printer::StackModelPrinter)
    while !isempty(printer.stack) # force closing
        end_current_state(io, printer)
        pop!(printer.stack)
    end
end

function finalize(io::IO, printer::FlatModelPrinter)
    reset(printer.ctx)
    printer.prevctx != printer.ctx && apply_changes(io, printer)
end


function Base.show(io::IO, ::MIME"text/plain", printer::AbstractPrinter)
    reset(printer)
    if get(io, :color, false)::Bool
        write(io, printer.buf)
    end
end

end # module

using Test, ANSIColoredPrinters

@testset "isnormal" begin
    n = ANSIColoredPrinters.SGRColor()
    @test ANSIColoredPrinters.isnormal(n)

    c16 = ANSIColoredPrinters.SGRColor("30")
    @test !ANSIColoredPrinters.isnormal(c16)

    c256 = ANSIColoredPrinters.SGRColor("38_5", "000")
    @test !ANSIColoredPrinters.isnormal(c256)
end

@testset "is216color" begin
    c000 = ANSIColoredPrinters.SGRColor("38_5", "000")
    @test ANSIColoredPrinters.is216color(c000)

    c080808 = ANSIColoredPrinters.SGRColor("48_5", "080808")
    @test !ANSIColoredPrinters.is216color(c080808)

    cabc = ANSIColoredPrinters.SGRColor("38_2", "abc")
    @test !ANSIColoredPrinters.is216color(cabc)
end

@testset "set_16colors!" begin
    ctx = ANSIColoredPrinters.SGRContext()

    ANSIColoredPrinters.set_16colors!(ctx, "30")
    @test ctx.fg.class == "30"
    @test isempty(ctx.fg.hex)
    @test ANSIColoredPrinters.codes(ctx.fg) === (30,)

    ANSIColoredPrinters.set_16colors!(ctx, "47")
    @test ctx.bg.class == "47"
    @test isempty(ctx.bg.hex)
    @test ANSIColoredPrinters.codes(ctx.bg) === (47,)

    ANSIColoredPrinters.set_16colors!(ctx, "97")
    @test ctx.fg.class == "97"
    @test isempty(ctx.fg.hex)
    @test ANSIColoredPrinters.codes(ctx.fg) === (97,)

    ANSIColoredPrinters.set_16colors!(ctx, "100")
    @test ctx.bg.class == "100"
    @test isempty(ctx.bg.hex)
    @test ANSIColoredPrinters.codes(ctx.bg) === (100,)
end

@testset "set_256colors!" begin
    ctx = ANSIColoredPrinters.SGRContext()

    # 16 colors
    ANSIColoredPrinters.set_256colors!(ctx, "38", "1")
    @test ctx.fg.class == "31"
    @test isempty(ctx.fg.hex)
    @test ANSIColoredPrinters.codes(ctx.fg) === (31,)

    ANSIColoredPrinters.set_256colors!(ctx, "48", "6")
    @test ctx.bg.class == "46"
    @test isempty(ctx.bg.hex)
    @test ANSIColoredPrinters.codes(ctx.bg) === (46,)

    ANSIColoredPrinters.set_256colors!(ctx, "38", "15")
    @test ctx.fg.class == "97"
    @test isempty(ctx.fg.hex)
    @test ANSIColoredPrinters.codes(ctx.fg) === (97,)

    ANSIColoredPrinters.set_256colors!(ctx, "48", "8")
    @test ctx.bg.class == "100"
    @test isempty(ctx.bg.hex)
    @test ANSIColoredPrinters.codes(ctx.bg) === (100,)

    # 216 colors (6 * 6 * 6)
    ANSIColoredPrinters.set_256colors!(ctx, "38", "16")
    @test ctx.fg.class == "38_5"
    @test ctx.fg.hex == "000"
    @test ANSIColoredPrinters.codes(ctx.fg) === (38, 5, 16)

    ANSIColoredPrinters.set_256colors!(ctx, "48", "17")
    @test ctx.bg.class == "48_5"
    @test ctx.bg.hex == "00005f"
    @test ANSIColoredPrinters.codes(ctx.bg) === (48, 5, 17)

    ANSIColoredPrinters.set_256colors!(ctx, "38", "110")
    @test ctx.fg.class == "38_5"
    @test ctx.fg.hex == "87afd7"
    @test ANSIColoredPrinters.codes(ctx.fg) === (38, 5, 110)

    ANSIColoredPrinters.set_256colors!(ctx, "38", "230")
    @test ctx.fg.class == "38_5"
    @test ctx.fg.hex == "ffffd7"
    @test ANSIColoredPrinters.codes(ctx.fg) === (38, 5, 230)

    ANSIColoredPrinters.set_256colors!(ctx, "48", "231")
    @test ctx.bg.class == "48_5"
    @test ctx.bg.hex == "fff"
    @test ANSIColoredPrinters.codes(ctx.bg) === (48, 5, 231)

    # grays
    ANSIColoredPrinters.set_256colors!(ctx, "38", "232")
    @test ctx.fg.class == "38_5"
    @test ctx.fg.hex == "080808"
    @test ANSIColoredPrinters.codes(ctx.fg) === (38, 5, 232)

    ANSIColoredPrinters.set_256colors!(ctx, "48", "255")
    @test ctx.bg.class == "48_5"
    @test ctx.bg.hex == "eee"
    @test ANSIColoredPrinters.codes(ctx.bg) === (48, 5, 255)
end

@testset "set_24bitcolors" begin
    ctx = ANSIColoredPrinters.SGRContext()

    ANSIColoredPrinters.set_24bitcolors!(ctx, "38", "0", "128", "255")
    @test ctx.fg.class == "38_2"
    @test ctx.fg.hex == "0080ff"
    @test ANSIColoredPrinters.codes(ctx.fg) === (38, 2, 0, 128, 255)

    ANSIColoredPrinters.set_24bitcolors!(ctx, "48", "170", "187", "204")
    @test ctx.bg.class == "48_2"
    @test ctx.bg.hex == "abc"
    @test ANSIColoredPrinters.codes(ctx.bg) === (48, 2, 170, 187, 204)

    # 216 colors
    ANSIColoredPrinters.set_24bitcolors!(ctx, "38", "0", "0", "0")
    @test ctx.fg.class == "38_5"
    @test ctx.fg.hex == "000"
    @test ANSIColoredPrinters.codes(ctx.fg) === (38, 5, 16)

    ANSIColoredPrinters.set_24bitcolors!(ctx, "48", "0", "0", "95")
    @test ctx.bg.class == "48_5"
    @test ctx.bg.hex == "00005f"
    @test ANSIColoredPrinters.codes(ctx.bg) === (48, 5, 17)

    # grays
    ANSIColoredPrinters.set_24bitcolors!(ctx, "38", "8", "8", "8")
    @test ctx.fg.class == "38_5"
    @test ctx.fg.hex == "080808"
    @test ANSIColoredPrinters.codes(ctx.fg) === (38, 5, 232)

    ANSIColoredPrinters.set_24bitcolors!(ctx, "48", "238", "238", "238")
    @test ctx.bg.class == "48_5"
    @test ctx.bg.hex == "eee"
    @test ANSIColoredPrinters.codes(ctx.bg) === (48, 5, 255)
end

using Test, ANSIColoredPrinters

function repr_html(printer::HTMLPrinter)
    result = repr("text/html", printer)
    take!(printer.buf)
    return result
end

@testset "plain" begin
    buf = IOBuffer()
    printer = HTMLPrinter(buf)

    print(buf, "This is a plain text.")
    @test repr_html(printer) == "<pre>This is a plain text.</pre>"
end

@testset "escape" begin
    buf = IOBuffer()
    printer = HTMLPrinter(buf)

    print(buf, "\"HTMLWriter\" uses '<pre>' & '<span>' elements.")
    result = repr_html(printer)
    @test result == "<pre>&quot;HTMLWriter&quot; uses &#39;&lt;pre&gt;&#39; &amp; " *
                    "&#39;&lt;span&gt;&#39; elements.</pre>"
end

@testset "single modification" begin
    buf = IOBuffer()
    printer = HTMLPrinter(buf)

    @testset "bold/faint" begin
        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[1m", " Bold ")
        print(buf, "\e[2m", " Faint ")
        print(buf, "\e[22m", " Normal ")
        result = repr_html(printer)
        @test result == """<pre> Normal <span class="sgr1"> Bold </span>""" *
                        """<span class="sgr2"> Faint </span> Normal </pre>"""
    end

    @testset "fg/bg" begin
        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[36m", " CyanFG ")
        print(buf, "\e[39;44m", " BlueBG ")
        print(buf, "\e[49m", " Normal ")
        result = repr_html(printer)
        @test result == """<pre> Normal <span class="sgr36"> CyanFG </span>""" *
                        """<span class="sgr44"> BlueBG </span> Normal </pre>"""
    end

    @testset "blink" begin
        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[5m", " Blink ")
        print(buf, "\e[6m", " RapidBlink ")
        print(buf, "\e[25m", " Normal ")
        result = repr_html(printer)
        @test result == """<pre> Normal <span class="sgr5"> Blink </span>""" *
                        """<span class="sgr6"> RapidBlink </span> Normal </pre>"""
    end
end

@testset "nested modification" begin
    buf = IOBuffer()
    printer = HTMLPrinter(buf)

    @testset "bold/italic" begin
        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[1m", " Bold ")
        print(buf, "\e[3m", " Bold-Italic ")
        print(buf, "\e[23m", " Bold ")
        print(buf, "\e[0m", " Normal ")
        result = repr_html(printer)
        @test result == """<pre> Normal <span class="sgr1"> Bold """ *
                        """<span class="sgr3"> Bold-Italic </span>""" *
                        """ Bold </span> Normal </pre>"""

        print(buf, "\e[3m", " Italic ")
        print(buf, "\e[1m", " Bold-Italic ")
        print(buf, "\e[22m", " Italic ")
        print(buf, "\e[0m", " Normal ")
        result = repr_html(printer)
        @test result == """<pre><span class="sgr3"> Italic """ *
                        """<span class="sgr1"> Bold-Italic </span>""" *
                        """ Italic </span> Normal </pre>"""
    end

    @testset "bold/fg" begin
        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[1m", " Bold ")
        print(buf, "\e[36m", " Bold-CyanFG ")
        print(buf, "\e[39m", " Bold ")
        print(buf, "\e[0m", " Normal ")
        result = repr_html(printer)
        @test result == """<pre> Normal <span class="sgr1"> Bold """ *
                        """<span class="sgr36"> Bold-CyanFG </span>""" *
                        """ Bold </span> Normal </pre>"""
    end

    @testset "strike/blink" begin
        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[9m", " Strike ")
        print(buf, "\e[5m", " Strike-Blink ")
        print(buf, "\e[25m", " Strike ")
        print(buf, "\e[29m", " Normal ")
        result = repr_html(printer)
        @test result == """<pre> Normal <span class="sgr9"> Strike """ *
                        """<span class="sgr5"> Strike-Blink </span>""" *
                        """ Strike </span> Normal </pre>"""
    end

    @testset "fg/bg" begin
        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[96m", " LightCyanFG ")
        print(buf, "\e[45m", " LightCyanFG-MagentaBG ")
        print(buf, "\e[49m", " LightCyanFG ")
        print(buf, "\e[39m", " Normal ")
        result = repr_html(printer)
        @test result == """<pre> Normal <span class="sgr96"> LightCyanFG """ *
                        """<span class="sgr45"> LightCyanFG-MagentaBG </span>""" *
                        """ LightCyanFG </span> Normal </pre>"""
    end
end

@testset "overlapped modification" begin
    buf = IOBuffer()
    printer = HTMLPrinter(buf)

    @testset "bold/fg" begin
        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[1m", " Bold ")
        print(buf, "\e[36m", " Bold-CyanFG ")
        print(buf, "\e[22;36m", " CyanFG ")
        print(buf, "\e[39m", " Normal ")
        result = repr_html(printer)
        @test result == """<pre> Normal <span class="sgr1"> Bold """ *
                        """<span class="sgr36"> Bold-CyanFG </span></span>""" *
                        """<span class="sgr36"> CyanFG </span> Normal </pre>"""
    end

    @testset "fg/bg" begin
        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[96m", " LightCyanFG ")
        print(buf, "\e[45m", " LightCyanFG-MagentaBG ")
        print(buf, "\e[39m", " MagentaBG ")
        print(buf, "\e[49m", " Normal ")
        result = repr_html(printer)
        @test result == """<pre> Normal <span class="sgr96"> LightCyanFG """ *
                        """<span class="sgr45"> LightCyanFG-MagentaBG </span></span>""" *
                        """<span class="sgr45"> MagentaBG </span> Normal </pre>"""
    end
end

@testset "force reset" begin
    buf = IOBuffer()
    printer = HTMLPrinter(buf)

    print(buf, "\e[7m", " Invert ")
    print(buf, "\e[8m", " Conceal ")
    result = repr_html(printer)
    @test result == """<pre><span class="sgr7"> Invert <span class="sgr8"> Conceal """ *
                    """</span></span></pre>"""
end

@testset "256 colors" begin
    buf = IOBuffer()
    printer = HTMLPrinter(buf)

    print(buf, "\e[38;5;4m", " Blue(FG) ")
    print(buf, "\e[48;5;16m", " #000(BG) ")
    print(buf, "\e[38;5;110m", " #87afd7(FG) ")
    print(buf, "\e[48;5;255m", " #eee(BG) ")

    result = repr_html(printer)
    @test result == """<pre><span class="sgr34"> Blue(FG) """ *
                    """<span class="sgr48_5" style="background:#000"> #000(BG) """ *
                    """</span></span><span class="sgr48_5" style="background:#000">""" *
                    """<span class="sgr38_5" style="color:#87afd7"> #87afd7(FG) """ *
                    """</span></span><span class="sgr38_5" style="color:#87afd7">""" *
                    """<span class="sgr48_5" style="background:#eee"> #eee(BG) """ *
                    """</span></span></pre>"""
end

@testset "24-bit colors" begin
    buf = IOBuffer()
    printer = HTMLPrinter(buf)

    print(buf, "\e[38;2;0;128;255m", " #0080ff(FG) ")
    print(buf, "\e[48;2;238;238;238m", " #eee(BG) ")
    print(buf, "\e[38;2;170;187;204m", " #abc(FG) ")

    result = repr_html(printer)
    @test result == """<pre><span class="sgr38_2" style="color:#0080ff"> #0080ff(FG) """ *
                    """<span class="sgr48_5" style="background:#eee"> #eee(BG) """ *
                    """</span></span><span class="sgr48_5" style="background:#eee">""" *
                    """<span class="sgr38_2" style="color:#abc"> #abc(FG) """ *
                    """</span></span></pre>"""
end

@testset "callback" begin
    @testset "use default" begin
        counter = 0
        function cb(io, printer, tag, attrs)
            startswith(tag, "/") && return nothing
            push!(attrs, :id => tag * string(counter))
            counter += 1
            return nothing
        end

        buf = IOBuffer()
        printer = HTMLPrinter(buf, root_class = "root test", root_tag = "code", callback = cb)

        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[38;5;255m", " #eee(FG) ")
        print(buf, "\e[0m", " Normal ")

        result = repr_html(printer)
        @test result == """<code class="root test" id="code0"> Normal """ *
                        """<span class="sgr38_5" id="span1" style="color:#eee">""" *
                        """ #eee(FG) </span> Normal </code>"""
    end

    @testset "prevent default" begin
        dom = Tuple[(:rootnode, Tuple[])]
        function cb(io, printer, tag, attrs)
            text = String(take!(io))
            parent = dom[end]
            children = parent[end]
            isempty(text) || push!(children, (:textnode, text))

            if startswith(tag, "/")
                pop!(dom)
            else
                parent = (Symbol(tag), attrs, Tuple[])
                push!(children, parent)
                push!(dom, parent)
            end
            return true
        end

        buf = IOBuffer()
        printer = HTMLPrinter(buf, callback = cb)

        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[38;5;255m", " #eee(FG) ")
        print(buf, "\e[0m", " Normal ")

        result = repr_html(printer)
        @test result == ""
        @test dom[1] ==
                (:rootnode, Tuple[
                    (:pre, Dict{Symbol,String}(), Tuple[
                        (:textnode, " Normal "),
                        (:span, Dict(:class => "sgr38_5", :style => "color:#eee"), Tuple[
                            (:textnode, " #eee(FG) ")
                        ]),
                        (:textnode, " Normal ")
                    ])
                ])
    end
end

using Test, ANSIColoredPrinters

function repr_color(printer::PlainTextPrinter)
    result = repr("text/plain", printer, context = :color => true)
    get(ENV, "JULIA_DEBUG", "") == "" || println(result)
    take!(printer.buf)
    return result
end

@testset "no color" begin
    buf = IOBuffer()
    printer = PlainTextPrinter(buf)
    print(buf, "\e[36m", " CyanFG ")
    print(buf, "\e[39m", " Normal ")
    result = repr("text/plain", printer)
    @test result == " CyanFG  Normal "
end

@testset "single modification" begin
    buf = IOBuffer()
    printer = PlainTextPrinter(buf)

    @testset "bold/faint" begin
        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[1m", " Bold ")
        print(buf, "\e[2m", " Faint ")
        print(buf, "\e[22m", " Normal ")
        @test repr_color(printer) == " Normal \e[1m Bold \e[2m Faint \e[m Normal "
    end

    @testset "fg/bg" begin
        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[36m", " CyanFG ")
        print(buf, "\e[39;44m", " BlueBG ")
        print(buf, "\e[49m", " Normal ")
        @test repr_color(printer) == " Normal \e[36m CyanFG \e[39;44m BlueBG \e[m Normal "
    end

    @testset "blink" begin
        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[5m", " Blink ")
        print(buf, "\e[6m", " RapidBlink ")
        print(buf, "\e[25m", " Normal ")
        @test repr_color(printer) == " Normal \e[5m Blink \e[6m RapidBlink \e[m Normal "
    end
end

@testset "nested modification" begin
    buf = IOBuffer()
    printer = PlainTextPrinter(buf)

    @testset "bold/italic" begin
        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[1m", " Bold ")
        print(buf, "\e[3m", " Bold-Italic ")
        print(buf, "\e[23m", " Bold ")
        print(buf, "\e[0m", " Normal ")
        result = repr_color(printer)
        @test result == " Normal \e[1m Bold \e[3m Bold-Italic \e[23m Bold \e[m Normal "

        print(buf, "\e[3m", " Italic ")
        print(buf, "\e[1m", " Bold-Italic ")
        print(buf, "\e[22m", " Italic ")
        print(buf, "\e[0m", " Normal ")
        result = repr_color(printer)
        @test result == "\e[3m Italic \e[1m Bold-Italic \e[22m Italic \e[m Normal "
    end

    @testset "bold/fg" begin
        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[1m", " Bold ")
        print(buf, "\e[36m", " Bold-CyanFG ")
        print(buf, "\e[39m", " Bold ")
        print(buf, "\e[0m", " Normal ")
        result = repr_color(printer)
        @test result == " Normal \e[1m Bold \e[36m Bold-CyanFG \e[39m Bold \e[m Normal "
    end

    @testset "strike/blink" begin
        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[9m", " Strike ")
        print(buf, "\e[5m", " Strike-Blink ")
        print(buf, "\e[25m", " Strike ")
        print(buf, "\e[29m", " Normal ")
        result = repr_color(printer)
        @test result == " Normal \e[9m Strike \e[5m Strike-Blink \e[25m Strike \e[m Normal "
    end

    @testset "fg/bg" begin
        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[96m", " LightCyanFG ")
        print(buf, "\e[45m", " LightCyanFG-MagentaBG ")
        print(buf, "\e[49m", " LightCyanFG ")
        print(buf, "\e[39m", " Normal ")
        result = repr_color(printer)
        @test result == " Normal \e[96m LightCyanFG \e[45m LightCyanFG-MagentaBG " *
                        "\e[49m LightCyanFG \e[m Normal "
    end
end

@testset "overlapped modification" begin
    buf = IOBuffer()
    printer = PlainTextPrinter(buf)

    @testset "bold/fg" begin
        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[1m", " Bold ")
        print(buf, "\e[36m", " Bold-CyanFG ")
        print(buf, "\e[22;36m", " CyanFG ")
        print(buf, "\e[39m", " Normal ")
        result = repr_color(printer)
        @test result == " Normal \e[1m Bold \e[36m Bold-CyanFG " *
                        "\e[22;36m CyanFG \e[m Normal "
    end

    @testset "fg/bg" begin
        print(buf, "\e[0m", " Normal ")
        print(buf, "\e[96m", " LightCyanFG ")
        print(buf, "\e[45m", " LightCyanFG-MagentaBG ")
        print(buf, "\e[39m", " MagentaBG ")
        print(buf, "\e[49m", " Normal ")
        result = repr_color(printer)
        @test result == " Normal \e[96m LightCyanFG \e[45m LightCyanFG-MagentaBG " *
                        "\e[39m MagentaBG \e[m Normal "
    end
end

@testset "force reset" begin
    buf = IOBuffer()
    printer = PlainTextPrinter(buf)

    print(buf, "\e[7m", " Invert ")
    print(buf, "\e[8m", " Conceal ")
    @test repr_color(printer) == "\e[7m Invert \e[8m Conceal \e[m"
end

@testset "256 colors" begin
    buf = IOBuffer()
    printer = PlainTextPrinter(buf)

    print(buf, "\e[38;5;4m", " Blue(FG) ")
    print(buf, "\e[48;5;16m", " #000(BG) ")
    print(buf, "\e[38;5;110m", " #87afd7(FG) ")
    print(buf, "\e[48;5;255m", " #eee(BG) ")

    result = repr_color(printer)
    @test result == "\e[34m Blue(FG) \e[48;5;16m #000(BG) " *
                    "\e[38;5;110m #87afd7(FG) \e[48;5;255m #eee(BG) \e[m"
end

@testset "24-bit colors" begin
    buf = IOBuffer()
    printer = PlainTextPrinter(buf)

    print(buf, "\e[38;2;0;128;255m", " #0080ff(FG) ")
    print(buf, "\e[48;2;238;238;238m", " #eee(BG) ")
    print(buf, "\e[38;2;170;187;204m", " #abc(FG) ")

    result = repr_color(printer)
    @test result == "\e[38;2;0;128;255m #0080ff(FG) \e[48;5;255m #eee(BG) " *
                    "\e[38;2;170;187;204m #abc(FG) \e[m"
end

# ANSIColoredPrinters

ANSIColoredPrinters converts a text qualified by
[ANSI escape codes](https://en.wikipedia.org/wiki/ANSI_escape_code) to another
format. Currently, [plain text](@ref plain_text) and [HTML](@ref html) output
are supported.

## Installation
The package can be installed with the Julia package manager. Run:
```julia
import Pkg
Pkg.add("ANSIColoredPrinters")
```
or, from the Julia REPL, type `]` to enter the Pkg REPL mode and run:
```julia
pkg> add ANSIColoredPrinters
```

## Usage

All you need to do is to pass an `IO` object, which contains a text qualified
with ANSI escape codes as the first argument of the constructor of a printer
(e.g. [`HTMLPrinter`](@ref)).

On environments which support `MIME"text/html"` display (e.g. this Documenter's
HTML output), the text is displayed as HTML with its ANSI escape codes are
translated into HTML elements by [`HTMLPrinter`](@ref).

```@example ex
using ANSIColoredPrinters
using Crayons

buf = IOBuffer()
Crayons.print_logo(buf) # this outputs ANSI escape codes.

printer = HTMLPrinter(buf, root_class="documenter-example-output")
```

Perhaps your browser is displaying a colored logo, but the `HTMLPrinter`
actually outputs HTML code that looks like:

```@example ex
htmlsrc = IOBuffer() # hide
show(htmlsrc, MIME"text/html"(), printer) # hide
print(String(take!(htmlsrc))[1:119], "...") # hide
```

In addition, the colors and text styles are controlled by the CSS in the host
document (e.g. [`default.css`](./assets/default.css)).

# Supported Codes

The following are examples of the ANSI escape codes which are supported (i.e.
interpreted as a valid input) by [`HTMLPrinter`](@ref). Note that the
representation depends on the renderer, since some codes are not widely
supported and there are some code conflicts.

```@setup ex
using ANSIColoredPrinters
```
## Bold and Faint
```@example ex
buf = IOBuffer()
print(buf, "\e[0m", "Normal ")
print(buf, "\e[1m", "Bold ")
print(buf, "\e[2m", "Faint ") # this unsets the "bold"
print(buf, "\e[0m", "Normal ")
HTMLPrinter(buf, root_class="documenter-example-output")
```

## Italic
```@example ex
buf = IOBuffer()
print(buf, "\e[0m", "Normal ")
print(buf, "\e[3m", "Italic ")
print(buf, "\e[1m", "Bold-Italic ") # this keeps the "italic"
print(buf, "\e[23m", "Bold ") # this keeps the "bold"
print(buf, "\e[0m", "Normal ")
HTMLPrinter(buf, root_class="documenter-example-output")
```

## Underline and Strikethrough
```@example ex
buf = IOBuffer()
print(buf, "\e[0m", "Normal ")
print(buf, "\e[4m", " Underline ", "\e[24m", " ")
print(buf, "\e[9m", " Striethrough ", "\e[29m", " ")
print(buf, "\e[4;9m", " Both ", "\e[m")
HTMLPrinter(buf, root_class="documenter-example-output")
```
## Invert
The invert code swaps the foreground and background colors. However, the support
is limited. You will need to force the foreground and background colors to be
switched manually, or convert the style afterwards using JavaScript etc.

```@example ex
buf = IOBuffer()
print(buf, "\e[0m", "Normal ")
print(buf, "\e[7m", "Invert ")
print(buf, "\e[27m", "Normal ")
print(buf, "\e[7;100m", "GrayText? ") # not supported by default.css
print(buf, "\e[34m", "BlueBG? ") # not supported by default.css
print(buf, "\e[0m", "Normal ")
HTMLPrinter(buf, root_class="documenter-example-output")
```

## Conceal
```@example ex
buf = IOBuffer()
print(buf, "\e[0m", "Normal ")
print(buf, "\e[8m", "Conceal ")
print(buf, "\e[31;47m", "Red1 ") # this is still concealed
print(buf, "\e[0m", "Normal ")
print(buf, "\e[31;47m", "Red2 ")
print(buf, "\e[8m", "Conceal ")
print(buf, "\e[28m", "Red3 ")
print(buf, "\e[0m", "Normal ")
HTMLPrinter(buf, root_class="documenter-example-output")
```

## 16 colors
The 16 colors correspond to the color symbols which can be specified in the
argument of
[`printstyled`](https://docs.julialang.org/en/v1/base/io-network/#Base.printstyled)
(e.g. `:black`, `:red`, `:green`, `:light_blue`). Their sRGB values are
environment-dependent. This document defines their actual colors in a CSS file.

### Basic colors
```@example ex
buf = IOBuffer()
for fg in [30:37; 39] # foreground color
    for bg in [40:47; 49] # background color
        print(buf, "\e[$fg;$(bg)m  $fg; $bg ")
    end
    println(buf)
end
HTMLPrinter(buf, root_class="documenter-example-output")
```

### Light colors
```@example ex
buf = IOBuffer()
for fg in [90:97; 39] # foreground color
    for bg in [100:107; 49] # background color
        print(buf, "\e[$fg;$(bg)m  $fg;$bg ")
    end
    println(buf)
end
HTMLPrinter(buf, root_class="documenter-example-output")
```

## 256 colors
The 256 colors correspond to the integer codes which can be specified in the
argument of printstyled.

```@example ex
buf = IOBuffer()
for color in 0:15 # same as the 16 colors above.
    print(buf, "\e[38;5;$color;48;5;$(color)m  ")
    print(buf, "\e[49m", lpad(color, 3), " ")
    color % 8 == 7 && println(buf)
end
for color in 16:231 # 6 × 6 × 6 = 216 colors
    (color - 16) % 12 == 0 && println(buf)
    print(buf, "\e[38;5;$color;48;5;$(color)m  ")
    print(buf, "\e[49m", lpad(color, 3), " ")
end
println(buf)
for color in 232:255 # grayscale in 24 steps
    (color - 232) % 12 == 0 && println(buf)
    print(buf, "\e[38;5;$color;48;5;$(color)m  ")
    print(buf, "\e[49m", lpad(color, 3), " ")
end
print(buf, "\e[m")
HTMLPrinter(buf, root_class="documenter-example-output")
```
## 24-bit colors

```@example ex
buf = IOBuffer()
print(buf, " \e[48;2;56;152;38m  \n")
print(buf, "\e[48;2;203;60;51m  ")
print(buf, "\e[48;2;149;88;178m  ")
print(buf, "\e[49;38;2;64;99;216m  24-bit RGB\e[m")
HTMLPrinter(buf, root_class="documenter-example-output")
```

# Output Formats
```@setup ex
using ANSIColoredPrinters
```
## [Plain Text](@id plain_text)

[`PlainTextPrinter`](@ref) prints a plain text with ANSI escape codes as a plain
text (`MIME"text/plain"`). This may seem useless, but it has two major benefits.

One is the stripping of ANSI escape codes. You can get rid of ANSI escape codes
by printing a text to an `IO` object with `:color` I/O property `false`.

The other is the optimization of verbose ANSI escape codes.

### Examples
```@repl ex
src = IOBuffer();

printstyled(IOContext(src, :color => true), "light ", color=:light_cyan);
printstyled(IOContext(src, :color => true), "cyan", color=:light_cyan);

read(seekstart(src), String) # source text

printer = PlainTextPrinter(src);
repr("text/plain", printer, context = :color => false) # stripped
repr("text/plain", printer, context = :color => true) # optimized
```

!!! note
    The initial and final states are implicitly interpreted as being "Normal",
    i.e. the state with `"\e[0m"`.

## [HTML](@id html)
[`HTMLPrinter`](@ref) prints a plain text with ANSI escape codes as an HTML
fragment (`MIME"text/html"`).

See [Supported Codes](@ref) for examples.

The [`HTMLPrinter`](@ref) constructor supports the `callback` keyword argument.
The `callback` method will be called just before writing HTML tags. You can
rewrite the attributes in your `callback` methods. You can also prevent the
default tag writing by setting the return value of the `callback` method to
something other than `nothing`.

```@example ex
src = IOBuffer();
print(src, " Normal ", "\e[48;5;246m", " GrayBG ", "\e[0m", " Normal ");

HTMLPrinter(src) # without callback method
```

```@repl ex
function cb(io::IO, printer::HTMLPrinter, tag::String, attrs::Dict{Symbol, String})
    text = String(take!(io))
    @show text
    @show tag, attrs
    return true # prevent default writing
end;

dummy = IOBuffer();
show(dummy, MIME"text/html"(), HTMLPrinter(src, callback = cb));
```
